<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

// No direct access.
defined('_JEXEC') or die;

jimport('joomla.application.component.modelform');
jimport('joomla.event.dispatcher');

/**
 * Pdjx model.
 */
class PaiddownloadsjxModelFile extends JModelForm
{
    
    var $_item = null;
    var $_ID = null;
	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @since	1.6
	 */
	protected function populateState()
	{
		$app = JFactory::getApplication('com_paiddownloadsjx');

		// Load state from the request userState on edit or from the passed variable on default
        if (JFactory::getApplication()->input->get('layout') == 'edit') {
            $id = JFactory::getApplication()->getUserState('com_paiddownloadsjx.edit.file.id');
        } else {
            $id = JFactory::getApplication()->input->get('id');
            JFactory::getApplication()->setUserState('com_paiddownloadsjx.edit.file.id', $id);
        }
		$this->setState('file.id', $id);

		// Load the parameters.
		$params = $app->getParams();
        $params_array = $params->toArray();
        if(isset($params_array['item_id'])){
            $this->setState('file.id', $params_array['item_id']);
        }
		$this->setState('params', $params);

	}
        

	/**
	 * Method to get an ojbect.
	 *
	 * @param	integer	The id of the object to get.
	 *
	 * @return	mixed	Object on success, false on failure.
	 */
	public function &getData($id = null)
	{
		
		if ($this->_item === null)
		{
			$this->_item = false;

			if (empty($id)) {
				$id = $this->getState('file.id');
			}
			if (empty($id)) {
				$id = $this->_ID;
			}

			// Get a level row instance.
			$table = $this->getTable();
			//echo "JAA".$id;
			// Attempt to load the row.
			if ($table->load($id))
			{
				// Check published state.
				if ($published = $this->getState('filter.published'))
				{
					if ($table->state != $published) {
						return $this->_item;
					}
				}

				// Convert the JTable to a clean JObject.
				$properties = $table->getProperties(1);
				$this->_item = JArrayHelper::toObject($properties, 'JObject');
				
				//jimport('joomla.application.component.helper');
		    	$cnf = JComponentHelper::getParams('com_paiddownloadsjx');
				//test mode
				if($this->_item->testmode==1){
					$this->_item->action="https://www.sandbox.paypal.com/cgi-bin/webscr";
					$this->_item->business=$cnf->get('test_ppemail');
					
				}else{
					$this->_item->action="https://www.paypal.com/cgi-bin/webscr";
					$this->_item->business=$cnf->get('ppemail');
				}
				
				//donation
				if($this->_item->donation==1){
					$this->_item->cmd="_donations";
					$this->_item->btnimg = $cnf->get('donate_btn');
					$this->_item->tax= 0;
				}else{
					$this->_item->cmd="_xclick";
					$this->_item->btnimg = $cnf->get('purchase_btn');
					
					if ($this->_item->taxcalc==1) {
						$this->_item->tax = round(($this->_item->tax * $this->_item->amount) / 100 , 2);
					}
				}
						
				$this->_item->return=JURI::root()."index.php?option=com_paiddownloadsjx&task=confirm";
				$this->_item->cancelurl=JURI::current();
				
			} elseif ($error = $table->getError()) {
				$this->setError($error);
			}
		}
		return $this->_item;
	}

    public function getSingle($id) {
        $dbo=$this->getDbo();
        $query="SELECT * FROM #__pdjx_files WHERE id = $id LIMIT 1";
        $dbo->setQuery($query);
        return $dbo->loadObject();
    }

	public function getMany($ids = []) {
        $dbo=$this->getDbo();
        $query="SELECT * FROM #__pdjx_files WHERE id IN (". implode(',', $ids) .")";
        $dbo->setQuery($query);
        return $dbo->loadObjectList();
    }

    public function getDataByElement($element) {
        $dbo=$this->getDbo();
        $element=$dbo->quote($element);
        $query="SELECT * FROM #__pdjx_files WHERE element = $element LIMIT 1";
        $dbo->setQuery($query);
        $this->_item = $dbo->loadObject();
        return $this->_item;
    }
    
	public function getTable($type = 'File', $prefix = 'PaiddownloadsjxTable', $config = array())
	{   
        $this->addTablePath(JPATH_ADMINISTRATOR.'/components/com_paiddownloadsjx/tables');
        return JTable::getInstance($type, $prefix, $config);
	}     

    
	/**
	 * Method to check in an item.
	 *
	 * @param	integer		The id of the row to check out.
	 * @return	boolean		True on success, false on failure.
	 * @since	1.6
	 */
	public function checkin($id = null)
	{
		// Get the id.
		$id = (!empty($id)) ? $id : (int)$this->getState('file.id');

		if ($id) {
            
			// Initialise the table
			$table = $this->getTable();

			// Attempt to check the row in.
            if (method_exists($table, 'checkin')) {
                if (!$table->checkin($id)) {
                    $this->setError($table->getError());
                    return false;
                }
            }
		}

		return true;
	}

	/**
	 * Method to check out an item for editing.
	 *
	 * @param	integer		The id of the row to check out.
	 * @return	boolean		True on success, false on failure.
	 * @since	1.6
	 */
	public function checkout($id = null)
	{
		// Get the user id.
		$id = (!empty($id)) ? $id : (int)$this->getState('file.id');

		if ($id) {
            
			// Initialise the table
			$table = $this->getTable();

			// Get the current user object.
			$user = JFactory::getUser();

			// Attempt to check the row out.
            if (method_exists($table, 'checkout')) {
                if (!$table->checkout($user->get('id'), $id)) {
                    $this->setError($table->getError());
                    return false;
                }
            }
		}

		return true;
	}    
    
	/**
	 * Method to get the profile form.
	 *
	 * The base form is loaded from XML 
     * 
	 * @param	array	$data		An optional array of data for the form to interogate.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	JForm	A JForm object on success, false on failure
	 * @since	1.6
	 */
	public function getForm($data = array(), $loadData = true)
	{
		// Get the form.
		$form = $this->loadForm('com_paiddownloadsjx.file', 'file', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) {
			return false;
		}

		return $form;
	}

	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	protected function loadFormData()
	{
		$data = $this->getData(); 
        
        return $data;
	}

	/**
	 * Method to save the form data.
	 *
	 * @param	array		The form data.
	 * @return	mixed		The user id on success, false on failure.
	 * @since	1.6
	 */
	public function save($data)
	{
		$id = (!empty($data['id'])) ? $data['id'] : (int)$this->getState('file.id');
        $state = (!empty($data['state'])) ? 1 : 0;
        $user = JFactory::getUser();

        if($id) {
            //Check the user can edit this item
            $authorised = $user->authorise('core.edit', 'com_paiddownloadsjx') || $authorised = $user->authorise('core.edit.own', 'com_paiddownloadsjx');
            if($user->authorise('core.edit.state', 'com_paiddownloadsjx') !== true && $state == 1){ //The user cannot edit the state of the item.
                $data['state'] = 0;
            }
        } else {
            //Check the user can create new items in this section
            $authorised = $user->authorise('core.create', 'com_paiddownloadsjx');
            if($user->authorise('core.edit.state', 'com_paiddownloadsjx') !== true && $state == 1){ //The user cannot edit the state of the item.
                $data['state'] = 0;
            }
        }

        if ($authorised !== true) {
            JError::raiseError(403, JText::_('JERROR_ALERTNOAUTHOR'));
            return false;
        }
        
        $table = $this->getTable();
        if ($table->save($data) === true) {
            return $id;
        } else {
            return false;
        }
        
	}
    
     function delete($data)
    {
        $id = (!empty($data['id'])) ? $data['id'] : (int)$this->getState('file.id');
        if(JFactory::getUser()->authorise('core.delete', 'com_paiddownloadsjx') !== true){
            JError::raiseError(403, JText::_('JERROR_ALERTNOAUTHOR'));
            return false;
        }
        $table = $this->getTable();
        if ($table->delete($data['id']) === true) {
            return $id;
        } else {
            return false;
        }
        
        return true;
    }
    
	public function incrDwnlCount(){
		$dbo=$this->getDbo();
		$id=$dbo->quote($this->_item->id);
		$query="UPDATE #__pdjx_files SET downl=downl+1 WHERE id = $id";
		$dbo->setQuery($query);
		$dbo->execute();
	}
    
}