<?php
/**
 * @version     2.5.1
 * @package     com_pdjx
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Tools JX <customers@toolsjx.com> - http://www.toolsjx.com
 */

header('Content-Type: text/xml; charset=utf-8');

$app  = JFactory::getApplication();
$menu = $app->getMenu();

$file = $this->file;
$versions = $this->versions;


?>
<?php echo '<?xml version="1.0" encoding="UTF-8"?>'; ?>
<?php if ($file->type == 'package' && false) : ?>
    <extensionset name="<?= $file->itemname ?>">
        <?php foreach ($this->package_files as $package_file) : ?>
            <?php $lastVersion = end($package_file->versions) ?>
            <extension name="<?= $package_file->itemname ?>" element="<?= $package_file->element ?>" type="<?= $package_file->type ?>" version="<?= $lastVersion->version ?>" detailsurl="<?= rtrim(JUri::base(), '/') . JRoute::_('index.php?option=com_paiddownloadsjx&view=versions&file_id='. $package_file->id .'&txn_hash='. $this->txn .'&element='. $package_file->element, FALSE) ?>"/>
        <?php endforeach; ?>
    </extensionset>
<?php else : ?>
    <updates>
        <?php foreach ($versions as $version) : ?>
            <update>
                <name><?= $file->itemname ?></name>
                <description><?= $file->description ?></description>
                <element><?= $file->element ?></element>
                <type><?= $file->type ?></type>
                <version><?= $version->version ?></version>
                <?php if ($version->infourl) : ?>
                    <infourl title="<?= $file->itemname ?>"><?= $version->infourl ?></infourl>
                <?php endif; ?>

                <downloads>
                    <downloadurl type="<?= $version->download_type ?>" format="<?= $version->download_format ?>"><?= rtrim(JUri::root(), '/') . JRoute::_('index.php?option=com_paiddownloadsjx&view=download&version_id='. $version->id .'&txn_hash='. $this->txn .'&element='. $file->element .'&download_format='. $version->download_format, FALSE) ?></downloadurl>
                </downloads>

                <tags>
                    <?php foreach (json_decode($version->rtags) as $tag) : ?>
                        <tag><?= $tag ?></tag>
                    <?php endforeach; ?>
                </tags>

                <?php if ($file->maintainer) : ?>
                    <maintainer><?= $file->maintainer ?></maintainer>
                <?php endif; ?>

                <?php if ($file->maintainerurl) : ?>
                    <maintainerurl><?= $file->maintainerurl ?></maintainerurl>
                <?php endif; ?>

                <client_id>1</client_id>

                <?php if ($version->joomla_version) : ?>
                    <targetplatform name="joomla" version="<?= $version->joomla_version ?>"/>
                <?php endif; ?>

                <?php if ($version->php_version) : ?>
                    <php_minimum><?= $version->php_version ?></php_minimum>
                <?php endif; ?>

                <?php if ($version->mysql_version) : ?>
                    <supported_databases mysql="<?= $version->mysql_version ?>"/>
                <?php endif; ?>
            </update>
        <?php endforeach; ?>
    </updates>
<?php endif; ?>